﻿function j4l_externalpdf (
    p_process in apex_plugin.t_process,
    p_plugin  in apex_plugin.t_plugin )
    return apex_plugin.t_process_exec_result
as
    v_return apex_plugin.t_process_exec_result;
    v_serverurl varchar(100);
    v_query varchar(100);
    v_layout varchar(100);
    l_xmldocument blob;
    l_finaldocument blob;
    l_report clob;
    v_template clob;
    v_output varchar(30);
    v_suffix varchar(30);
begin

v_serverurl := p_process.attribute_01;
v_query := p_process.attribute_02;
v_layout := p_process.attribute_03;
v_output := p_process.attribute_04;

v_suffix := ''; -- no suffix is PDF
if (v_output  = 'TRACE') then 
    v_suffix := '?TRACE=1';
elsif (v_output  = 'XLS') then 
    v_suffix := '?XLS=1';
end if;

v_serverurl :=  v_serverurl  ||  v_suffix;


SELECT  PAGE_TEMPLATE INTO l_report FROM APEX_050100.WWV_FLOW_REPORT_LAYOUTS WHERE  REPORT_LAYOUT_NAME = v_layout;
   
SYS.DBMS_LOB.CREATETEMPORARY(V_TEMPLATE, FALSE, SYS.DBMS_LOB.SESSION );
SYS.DBMS_LOB.OPEN(V_TEMPLATE, SYS.DBMS_LOB.LOB_READWRITE );
SYS.DBMS_LOB.COPY(V_TEMPLATE, l_report, SYS.DBMS_LOB.GETLENGTH(l_report) );


-- first get XML
      l_xmldocument := APEX_UTIL.GET_PRINT_DOCUMENT (
     p_application_id=> NV('APP_ID'),
     p_report_query_name=> v_query,
     p_report_layout_name => v_layout,
     p_report_layout_type=> 'xsl-fo',
     p_document_format=> 'XML' 
     );
     
-- this signature creates the final report, if works with p_print_server
    l_finaldocument := APEX_UTIL.GET_PRINT_DOCUMENT (
     P_REPORT_DATA=> l_xmldocument,
     P_REPORT_LAYOUT => V_TEMPLATE,
     p_report_layout_type=> 'xsl-fo',
     p_document_format=> 'PDF' ,
     p_print_server=> v_serverurl
     ); 
     
     SYS.DBMS_LOB.CLOSE( V_TEMPLATE );
     SYS.DBMS_LOB.FREETEMPORARY( V_TEMPLATE );

        sys.htp.init;  
           
        if (v_output = 'TRACE') then
            sys.owa_util.mime_header( 'text/html', FALSE );
            sys.htp.p('Content-Disposition: inline;'); 
        elsif  (v_output = 'XLS') then
            sys.owa_util.mime_header( 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet', FALSE );  
            sys.htp.p('Content-Disposition: attachment; filename="report.xlsx"' ); 
        else
            sys.owa_util.mime_header( 'application/pdf', FALSE );
            sys.htp.p('Content-Disposition: inline;'); 
        end if;
        sys.htp.p('Content-length: ' || sys.dbms_lob.getlength( l_finaldocument ));   
        sys.owa_util.http_header_close;  
  
        sys.wpg_docload.download_file( l_finaldocument );  
     
     v_return.success_message := 'OK!';
     return  v_return;
exception
    WHEN OTHERS THEN  -- handles all other errors
     raise_application_error(-20001,'An error was encountered creating the PDF - ' || v_serverurl || ' ' ||SQLCODE||' -ERROR- '||SQLERRM);
end j4l_externalpdf ;